import { AnyAction, Action } from 'redux';
export interface Operation<TData = any> {
    readonly id: OpId;
    readonly status: OpStatus;
    readonly data?: TData;
}
export declare type OpId = number | string;
export declare enum OpStatus {
    Started = "started",
    Success = "success",
    Error = "error"
}
export interface Ops<TData = any> {
    readonly [key: string]: Operation<TData>;
}
export interface OpsState extends Ops {
}
export declare type OpsReducerHandler<A extends AnyAction = AnyAction> = (state: OpsState, action: A) => OpsState;
export declare type OperationActionHandler = (state: OpsState, action: OperationAction) => OpsState;
export interface OperationAction<TData = any> extends Action {
    readonly payload: Operation<TData>;
}
export interface DeleteOperationAction extends AnyAction {
    readonly payload: {
        readonly id: OpId;
    };
}
export interface ResetOperationsAction extends AnyAction {
}
export interface OperationActionCreator {
    <TData = any>(id: OpId, status?: OpStatus, data?: TData): OperationAction<TData>;
}
export interface DeleteOperationActionCreator {
    (id: OpId): DeleteOperationAction;
}
export interface ResetOperationsActionCreator {
    (): AnyAction;
}
